using System;
using RomeScriptInterfaces;
using Scripts;

namespace Scripts
{
    [Serializable]
    public class InsanityRising : ScriptServer.IScript
    {
        
        // for our messaging
        private String msgTitle, msgText;
        private String msgSound = "message1.mp3";
        private String msgApplause = "/../../sounds/events/event_circus_01.wav";
        private String msgRiot = "/../../sounds/actions/soldier_knocked_01.wav";
        private String msgMummy = "/../../sounds/buildings/obelisk_04.wav";
        private String msgBaa = "/../../sounds/actions/sheep_05.wav";
        private String msgNoSound = "";
        private String invasion;
        
        // variables for current ratings
        private Int32 nPopulation, nCityFunds, nSavings;
        private Int32 nStartFunds = 0;
        private uint nFavor, nSecurity, nCulture, nProsperity, nInsanity, uInsanity;
        private uint uISecurity, uIProsperity, uICulture, uIFunds, uIResource, uIWorkers;
        private uint rInsanity = 0;
        private uint numEmployed = 0;
        // version specific targets
        private Int32 tDefeat = -5000;
        private uint uMaxInsanity = 0;
        private uint tFleeceWon = 99999999;
        private Int32 wFinalTreasury = 0;
        
        // flags to tell us whether specific events have happened
        private bool bInit = false;
        private bool bHercules = false;
        private bool bJason = false;
        private bool bAtalanta = false;
        private bool bAdvisor = false;
        private bool bIAplague = false;
        private bool bIAfire = false;
        private bool bIAcollapse = false;
        private bool bOdeum = false;
        private bool bJupiter = false;
        private bool bCardiff = false;
        private bool bYorkie = false;
        private bool bOhio = false;
        private bool bArashh = false;
        private bool[] bEmptyVenue = { false, false, false, false };

        // variables for different checks
        private uint nTime = 0;                    // derived from game.GameTime
        private uint nTicks = 0;
        private uint nHeroes = 0;         
        private uint[] nTimerCheck = { 300, 620, 940, 1260, 1580, 1900, 2220, 2540, 2860, 3180, 3340, 3500, 3580, 3660, 3740, 3835, 999999 };
        private String[] sTimeLeft = { "44", "40", "36", "32", "28", "24", "20", "16", "12", "8", "6", "4", "3", "2", "1", "0", "X" };
        private uint iMessage = 0;
        private uint iWarn = 0;
        private uint iAdvisor = 0;                 // no Insanity Advisor appointed
        private uint iFleece = 0;
        private uint uFleece = 0;
        private uint iState = 0;
        private uint iMaxVilla = 0;                // maximum level allowed by the Insanity Advisor
        private uint tInsanityCheck = 117;         // every 2 weeks, just before its end
        private uint tInsanityTip = 999999;
        private uint nInvasion = 1;                // Arashh the Lithuanian Viking
        private uint rPopulation = 750;            // population trigger for Arashh invasion
        private uint rDenarii = 10000;             // money trigger for Arashh invasion
        private uint tArashh = 800;                // first raid by Arashh
        private uint tFleece = 999999;
        private uint kCaerDidi = 1;
        private uint kEboracum = 2;
        private uint kOhio = 3;
        private uint kIolcus = 4;
        private uint kPagasae = 5;
        private uint kPherae = 6;
        private uint kSalmydessus = 7;
        private uint kColchis = 8;
        private uint kAresGrove = 9;
        private uint kDefeat = 10;                 // Defeat city
        private uint tTradeCheck = 340;

        // variables for wage and population checks
        private int nPlebWages = 0;                // starting wages for plebs
        private int nEquiteWages = 0;              // ...and equites

        // resource IDs
        private Int32 mIDGrain = IDMaker.FromString("C4cr Grain");
        private Int32 mIDVegetables = IDMaker.FromString("C4cr Vegetables");
        private Int32 mIDSand = IDMaker.FromString("C4cr Sand");
        private Int32 mIDArmor = IDMaker.FromString("C4cr Armor");
        private Int32 mIDWool = IDMaker.FromString("C4cr Wool");
        private Int32 mIDClay = IDMaker.FromString("C4cr Clay");
        private Int32 mIDMarble = IDMaker.FromString("C4cr Marble");
        private Int32 mIDGold = IDMaker.FromString("C4cr Gold");
        private Int32 mIDMeat = IDMaker.FromString("C4cr Meat");
        private Int32 mIDWine = IDMaker.FromString("C4cr Wine");
        private Int32 mIDIron = IDMaker.FromString("C4cr Iron");
        private Int32 mIDTimber = IDMaker.FromString("C4cr Timber");
        private Int32 mIDPerfume = IDMaker.FromString("C4cr Perfume");
        private Int32 mIDSilphium = IDMaker.FromString("C4cr Silphium");
        private Int32 mIDIncense = IDMaker.FromString("C4cr Incense");
        private Int32 mIDHoney = IDMaker.FromString("C4cr Honey");
        private Int32 mIDCosmetics = IDMaker.FromString("C4cr Cosmetics");

        // building IDs
        private Int32 mIDPalace1 = IDMaker.FromString("C4b Governor's Palace Small");
        private Int32 mIDPalace2 = IDMaker.FromString("C4b Governor's Palace Medium");
        private Int32 mIDPalace3 = IDMaker.FromString("C4b Governor's Palace Large");
        private Int32 mIDTaxOffice = IDMaker.FromString("C4b Office Tax Collector");
        private Int32 mIDPrefect = IDMaker.FromString("C4b Office Praefect");
            
        private Int32 mIDDomus1 = IDMaker.FromString("C4b Equites Housing 01");
        private Int32 mIDDomus2 = IDMaker.FromString("C4b Equites Housing 02");
        private Int32 mIDDomus3 = IDMaker.FromString("C4b Equites Housing 03");
        private Int32 mIDInsula1 = IDMaker.FromString("C4b Plebian home 01");
        private Int32 mIDInsula2 = IDMaker.FromString("C4b Plebian home 02");
        private Int32 mIDInsula3 = IDMaker.FromString("C4b Plebian home 03");
        private Int32 mIDVilla1 = IDMaker.FromString("C4b Patrician home 01");
        private Int32 mIDVilla3 = IDMaker.FromString("C4b Patrician home 03");
        private Int32 mIDEstate1 = IDMaker.FromString("C4b Patrician home 04");
        private Int32 mIDEstate2 = IDMaker.FromString("C4b Patrician home 05");
        private Int32 mIDEstate3 = IDMaker.FromString("C4b Patrician home 06");
        private Int32 mIDMansion1 = IDMaker.FromString("C4b Patrician home 07");
        private Int32 mIDMansion2 = IDMaker.FromString("C4b Patrician home 08");
        private Int32 mIDMansion3 = IDMaker.FromString("C4b Patrician home 09");
        private Int32 mIDForum = IDMaker.FromString("C4b service Forum");
        private Int32 mIDBasilica = IDMaker.FromString("C4b service Basilica");
        private string[] sPatricians = {"C4b Patrician home 01","C4b Patrician home 02","C4b Patrician home 03",
             "C4b Patrician home 04","C4b Patrician home 05","C4b Patrician home 06","C4b Patrician home 07",
             "C4b Patrician home 08","C4b Patrician home 09"};

        private Int32 mIDFountain = IDMaker.FromString("C4b infra Fountain");
        private Int32 mIDPumphouse = IDMaker.FromString("C4b Infra Pumphouse");
        private Int32 mIDReservoir = IDMaker.FromString("C4b service Reservoir");
        private Int32 mIDBarber = IDMaker.FromString("C4b service Barber shop");
        private Int32 mIDBathhouse = IDMaker.FromString("C4b service Bathhouse");
        private Int32 mIDClinic = IDMaker.FromString("C4b service Clinic");
        private Int32 mIDHospital = IDMaker.FromString("C4b service Hospital");
        private Int32 mIDLibrary = IDMaker.FromString("C4b service Library");
        private Int32 mIDSchool = IDMaker.FromString("C4b service School");
        //
        private Int32 mIDJupiterTemple = IDMaker.FromString("C4b Service Temple Jupiter");
        private Int32 mIDCeresTemple = IDMaker.FromString("C4b Service Temple Ceres");
        private Int32 mIDMarsTemple = IDMaker.FromString("C4b Service Temple Mars");
        private Int32 mIDBacchusTemple = IDMaker.FromString("C4b Service Temple Bacchus");
        private Int32 mIDMercuryTemple = IDMaker.FromString("C4b Service Temple Mercury");
        private Int32 mIDJupiterShrine = IDMaker.FromString("C4b Service Shrine Jupiter");
        private Int32 mIDCeresShrine = IDMaker.FromString("C4b Service Shrine Ceres");
        private Int32 mIDMarsShrine = IDMaker.FromString("C4b Service Shrine Mars");
        private Int32 mIDBacchusShrine = IDMaker.FromString("C4b Service Shrine Bacchus");
        private Int32 mIDMercuryShrine = IDMaker.FromString("C4b Service Shrine Mercury");
        //
        private Int32 mIDOdeum = IDMaker.FromString("C4b service Odeum");
        private Int32 mIDTheater = IDMaker.FromString("C4b service Theater");
        private Int32 mIDArena = IDMaker.FromString("C4b service Arena");
        private Int32 mIDColiseum = IDMaker.FromString("C4b service Coliseum");
        private Int32 mIDCircus = IDMaker.FromString("C4b service Circus");
        private Int32 mIDActor = IDMaker.FromString("C4b Training Actor");
        private Int32 mIDAnimalTrainer = IDMaker.FromString("C4b Training Animal");
        private Int32 mIDGladiator = IDMaker.FromString("C4b Training Gladiator");
        private Int32 mIDCharioteer = IDMaker.FromString("C4b Training Charioteer");
        //
        private Int32 mIDCattleFarm = IDMaker.FromString("C4b harvester Livestock farmer's house");
        private Int32 mIDSheepFarm = IDMaker.FromString("C4b harvester Wool farmer's house");
        private Int32 mIDSandCamp = IDMaker.FromString("C4b harvester Sand collector's house");
        private Int32 mIDClayCamp = IDMaker.FromString("C4b harvester Clay collector's house");
        private Int32 mIDLumberjack = IDMaker.FromString("C4b harvester Timber miller's house");
        private Int32 mIDIronMine = IDMaker.FromString("C4b harvester Iron miner's house");
        private Int32 mIDGoldMine = IDMaker.FromString("C4b harvester Gold miner's house");
        private Int32 mIDMarbleCamp = IDMaker.FromString("C4b harvester Marble collector's camp");
        private Int32 mIDGlassFactory = IDMaker.FromString("C4b factory Glass");
        private Int32 mIDJewelryFactory = IDMaker.FromString("C4b factory Jewelry");
        private Int32 mIDOliveOilFactory = IDMaker.FromString("C4b factory Olive Oil");
        private Int32 mIDWineFactory = IDMaker.FromString("C4b factory Wine");
        private Int32 mIDPotteryFactory = IDMaker.FromString("C4b factory Pottery");
        private Int32 mIDUtensilsFactory = IDMaker.FromString("C4b factory Utensils");
        private Int32 mIDWeaponsFactory = IDMaker.FromString("C4b factory Weapons");
        //
        private Int32 mIDFoodMarket = IDMaker.FromString("C4b Market Food");
        private Int32 mIDBasicMarket = IDMaker.FromString("C4b market Common");
        private Int32 mIDLuxuryMarket = IDMaker.FromString("C4b Market Luxury");
        private Int32 mIDExoticMarket = IDMaker.FromString("C4b Market Exotic");
        private Int32 mIDGranary = IDMaker.FromString("C4b infra Granary");
        private Int32 mIDWarehouse = IDMaker.FromString("C4b infra Warehouse");
        private Int32 mIDDepot = IDMaker.FromString("C4b Depot");
        private Int32 mIDPort = IDMaker.FromString("C4b Depot with Dock");
        //
        private Int32 mIDArmory = IDMaker.FromString("C4b Mil Armory");
        private Int32 mIDMessHall = IDMaker.FromString("C4b Mil Mess Hall");
        private Int32 mIDTower = IDMaker.FromString("C4b infra Tower");
        private Int32 mIDGatehouse = IDMaker.FromString("C4b infra Gate");
        private Int32 mIDDrillYard = IDMaker.FromString("C4b Mil Drill Yard");
        private Int32 mIDArchers = IDMaker.FromString("C4b Mil Fort Auxilia");
        private Int32 mIDLightInfantry = IDMaker.FromString("C4b Mil Fort Infantry Lt");    
        // 
        private Int32 mIDGarden = IDMaker.FromString("C4 Deco Garden");
        private Int32 mIDHedgeSmall = IDMaker.FromString("C4 Deco Hedge Small");
        private Int32 mIDHedgeLarge = IDMaker.FromString("C4 Deco Hedge Large");
        private Int32 mIDBushSmall = IDMaker.FromString("C4 Deco Bush Small");
        private Int32 mIDBushLarge = IDMaker.FromString("C4 Deco Bush Large");
        private Int32 mIDTreeSmall = IDMaker.FromString("C4 Deco Tree Small");
        private Int32 mIDTreeMedium = IDMaker.FromString("C4 Deco Tree Medium");
        private Int32 mIDTreeLarge = IDMaker.FromString("C4 Deco Tree Large");
        private Int32 mIDHedgeRowSmall = IDMaker.FromString("C4 Deco HedgeRow Small");
        private Int32 mIDHedgeRowLarge = IDMaker.FromString("C4 Deco HedgeRow Large");
        private Int32 mIDStatue1 = IDMaker.FromString("C4 Deco Statue 1");
        private Int32 mIDStatue2 = IDMaker.FromString("C4 Deco Statue 2");
        private Int32 mIDStatue3 = IDMaker.FromString("C4 Deco Statue 3");
        private Int32 mIDStatue4 = IDMaker.FromString("C4 Deco Statue 4");
        private Int32 mIDStatue5 = IDMaker.FromString("C4 Deco Statue 5");
        private Int32 mIDStatue6 = IDMaker.FromString("C4 Deco Statue 6");
        private Int32 mIDObelisk = IDMaker.FromString("C4b Statue Obelisk");
        

        // build button IDs
        private Int32 mUIIDStorage = IDMaker.FromString("STORAGE");
        private Int32 mUIIDPatHome = IDMaker.FromString("PAT_HOME");
        private Int32 mUIIDExoticMarket = IDMaker.FromString("MARKET_EXOTIC");
        
        private Int32 mUIIDSafety = IDMaker.FromString("SAFETY");
        private Int32 mUIIDMarble = -896256229;
        private Int32 mUIIDPrefect = 276325365;
        private Int32 mUIIDGrainFarm = 939069272;
        private Int32 mUIIDVegFarm = 899170814;
        private Int32 mUIIDCattleFarm = -456233970;
        private Int32 mUIIDOliveFarm = 697536400;
        private Int32 mUIIDGrapeFarm = -187939099;
        private Int32 mUIIDGrainField = 1892088299;
        private Int32 mUIIDVegField = 1892088301;
        private Int32 mUIIDCattlePasture = 1853760927;
        private Int32 mUIIDOliveGrove = 1892088303;        
        private Int32 mUIIDJupiterShrine = -1298997106;
        private Int32 mUIIDJupiterTemple = 1121480186;
        private Int32 mUIIDClinic = IDMaker.FromString("CLINIC");
        private Int32 mUIIDBarber = -1282219398;
        private Int32 mUIIDSchool = -1298997109;
        private Int32 mUIIDTax = 276325360;
        private Int32 mUIIDBust = IDMaker.FromString("STATUE1");
        private Int32 mUIIDStanding = IDMaker.FromString("STATUE2");
        private Int32 mUIIDHuntsman = IDMaker.FromString("STATUE3");
        private Int32 mUIIDHorseman = IDMaker.FromString("STATUE4");
        private Int32 mUIIDChariot = -1047491516;
        private Int32 mUIIDWingedChariot = -997158636;
        private Int32 mUIIDSmallHedgeRow = -1282219395;
        private Int32 mUIIDLargeHedgeRow = -1298997118;
        private Int32 mUIIDGarden = IDMaker.FromString("GARDEN1");
        private Int32 mUIIDSmallHedge = IDMaker.FromString("DECO1");
        private Int32 mUIIDLargeHedge = IDMaker.FromString("DECO7");
        private Int32 mUIIDSmallBush = IDMaker.FromString("DECO2");
        private Int32 mUIIDLargeBush = IDMaker.FromString("DECO4");
        private Int32 mUIIDSmallTree = IDMaker.FromString("DECO6");
        private Int32 mUIIDMediumTree = IDMaker.FromString("DECO3");
        private Int32 mUIIDLargeTree = IDMaker.FromString("DECO5");
        private Int32 mUIIDObelisk = IDMaker.FromString("PRESALE1");
        private Int32 mUIIDOdeum = 1740942627;
        private Int32 mUIIDTheater = -137606214;
        private Int32 mUIIDActor = 1806783073;
        private Int32 mUIIDArena = 1724165050;
        private Int32 mUIIDGladiator = 1806783075;
        private Int32 mUIIDColiseum = 1691448420;
        private Int32 mUIIDCircus = -2046596977;
        private Int32 mUIIDPlaza1 = IDMaker.FromString("PLAZA1");
        private Int32 mUIIDPlaza2 = IDMaker.FromString("PLAZA2");
        private Int32 mUIIDPlaza3 = IDMaker.FromString("PLAZA3");
        private Int32 mUIIDWall = IDMaker.FromString("WALL");
        private Int32 mUIIDSalary = 989726645;
         
        // The following declarations are necessary as this scenario uses custom standward wage changes
        private StandardWageManager mWageManagerPlebe = null;
        private StandardWageManager mWageManagerEques = null;

        private TMilitaryAI mMilitaryAI = null;
        private InvasionSetup[] mInvasions;

        // This is the main script loop
        public void Run(object gameInterface)
        {
            IGameQueryInterface gameQueryInterface = (IGameQueryInterface)gameInterface;
            switch (gameQueryInterface.RunReason)
            {
                case RunReason.kTick:
                    OnTick(gameQueryInterface);
                    break;

                case RunReason.kOnBeginScenario:
                    OnBeginScenario(gameQueryInterface);
                    break;

                case RunReason.kOnInvasionArrival:
                    OnInvasionArrival(gameQueryInterface);
                    break;

                case RunReason.kOnCohortTargetDestroyed:
                    OnCohortTargetDestroyed(gameQueryInterface);
                    break;

                case RunReason.kOnLoadScenario:
                    OnScenarioLoad(gameQueryInterface);
                    break;
            }
        }

        void OnTick(IGameQueryInterface game)
        {
            if (bInit)
            {
                bInit = false;
                ResetBaseUI(game);
            }

            game.ScriptDone = false;
            nTicks++;
            
            // Set our city ratings
            GetCityRatings(game);

            if (nTime > nTimerCheck[iMessage]) TimerMessage(game);

            // This is where all the Fleece sequence will go!
            if (nTime > tFleece)
                JasonStory(game);
            else if (nTime > tArashh)
                // check for invasion from the SLF
                ArashhInvasion(game);
            else if (bArashh && (game.BuildingsRazed > 0))
                StopCurrentInvasion(game);
            else if (nTime > tTradeCheck)
                TradeCheck(game);
            
            
            // mMilitaryAI.Update(game, 0.1);
        }

        ////////////////////////////////////////////////
        // This is where we get the city ratings etc
        void GetCityRatings(IGameQueryInterface game)
        {
            nTime = game.GameTime / 1000;           // time measured in seconds
            game.GetFavorRating(out nFavor);
            game.GetSecurityRating(out nSecurity);
            game.GetProsperityRating(out nProsperity);
            game.GetCultureRating(out nCulture);
            game.GetPopulation(out nPopulation);
            game.GetGovernorPersonalFunds(out nSavings);
            game.GetCityFunds(out nCityFunds);

            if (nStartFunds == 0) nStartFunds = nCityFunds;
            if (nStartFunds > 15000) game.SetFireCollapse(false);

            // check for defeat/victory triggers
            if ((nTime > 3859) || (nCityFunds < tDefeat))
                TriggerDefeat(game);
            else if ((nTime > 3840) && (nCityFunds >= 0) && (tFleeceWon < 999999))
            {
                game.ScriptDone = true;
                if (wFinalTreasury == 0) wFinalTreasury = nCityFunds;
            }
            //if (nTime > 3840) ScorePoints(game);
            
            if (nTime > tInsanityCheck) ShowInsanityRating(game);
            
            
        }

        //////////////////////////////////////////////////
        // Controls the raider invasions
        void ArashhInvasion(IGameQueryInterface game)
        {
            InvasionSetup mInvasion;
                        
            if ((nPopulation >= rPopulation) || (nCityFunds > rDenarii))
            {
                if (nPopulation >= rPopulation)
                    rPopulation += 750;
                else
                    rDenarii += 10000;
                
                DisplayMessage(game, "Arashh");
                invasion = "raid" + nInvasion.ToString(); ;
                mInvasion = new InvasionSetup(invasion, "Carthaginian", eInvasionType.kRaid, 0, 4, 0);
                mInvasion.AddCohort("ENEMY_CARTH_LT", 1, 1, 1);
                mInvasion.CreateInvasion(game, nInvasion, 0);
                game.StartInvasion(ref invasion);
                nInvasion++;
                bArashh = true;
                tArashh = nTime + 800;       // 40 weeks to next raid (at least)
            }
            else
                tArashh = nTime + 40;        // check every 2 weeks otherwise
        }


        //////////////////////////////////////////////////
        // Spawns traders for all open trade routes
        void TradeCheck(IGameQueryInterface game)
        {
            game.OpenTradeRoute(kIolcus);
            if (bCardiff) game.OpenTradeRoute(kCaerDidi);
            if (bYorkie) game.OpenTradeRoute(kEboracum);
            if (bOhio) game.OpenTradeRoute(kOhio);
            if (iFleece > 1) game.OpenTradeRoute(kPagasae);
            if (iFleece > 2) game.OpenTradeRoute(kPherae);
            if (iFleece > 3) game.OpenTradeRoute(kSalmydessus);
            if (iFleece > 4) game.OpenTradeRoute(kColchis);
            if (iFleece > 7) game.OpenTradeRoute(kAresGrove);
            tTradeCheck += 240;             // check every 3 months
        }

        
        
        ////////////////////////////////////////////////////////////////////////////
        // Insanity rating is calculated every 2 weeks
        // Current rating increases or decreases by 1 every week towards this value
        void ShowInsanityRating(IGameQueryInterface game)
        {
            uint nPump = 0;

            switch (iAdvisor)
            {
                case 0:
                    DisplayMessage(game, "Advisor_Guest");
                    iAdvisor = 1;
                    break;

                case 1:
                    if (nPalace(game) > 0)
                    {
                        DisplayMessage(game, "Guests_Arrive");
                        iAdvisor = 2;
                        iFleece = 1;
                        tFleece = nTime + 100;
                    }
                    break;

                case 2:
                    game.GetTotalBuildings(mIDPumphouse, out nPump);
                    if (nPump > 0)
                        DisplayMessage(game, "Pumphouse_C");
                    else
                        DisplayMessage(game, "Pumphouse_A");
                    iAdvisor++;
                    break;

                case 3:
                    msgTitle = "Insane_Advice_Title";
                    msgText = "Insane_Advice_Message";
                    game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                        (uint)MessageDisplay.kMessageDisplayTutorial, ref msgTitle, ref msgText, ref msgBaa);
                    iAdvisor++;
                    tInsanityTip = nTime + 80;
                    break;

                case 4:
                    if (nTime < 3840) GetInsanityRating(game);
                    nInsanity = uInsanity;
                    if (nInsanity > uMaxInsanity) uMaxInsanity = nInsanity;

                    if (nTime < 3820)
                        DisplayInsanity(game);
                    else
                        DisplayMaxInsanity(game);
                    
                    if ((nTime > tInsanityTip) && (nInsanity < 100)) InsanityHint(game);

                    if (nInsanity > rInsanity)
                    {
                        if (rInsanity == 25)
                        {
                            game.OpenTradeRoute(kCaerDidi);
                            DisplayWarning(game, "Caer_Didi");
                            game.FlashUIControl(mUIIDStorage, Toolset.MainGameFormID, 1000);
                            bCardiff = true;                       
                        }
                        else if (rInsanity == 50)
                        {
                            game.OpenTradeRoute(kEboracum);
                            DisplayWarning(game, "Eboracum");
                            game.FlashUIControl(mUIIDStorage, Toolset.MainGameFormID, 1000);
                            bYorkie = true;
                        }
                        else if (rInsanity == 75)
                        {
                            game.OpenTradeRoute(kOhio);
                            DisplayWarning(game, "Ohio");
                            game.FlashUIControl(mUIIDStorage, Toolset.MainGameFormID, 1000);
                            bOhio = true;
                        }
                        rInsanity += 5;
                    }
                    break;
            }
            
            tInsanityCheck += 40;
            
        }

        //////////////////////////////////////////////
        // Controls Insanity Rating calculation 
        void GetInsanityRating(IGameQueryInterface game)
        {
            uInsanity = 0;           // initialise
            InsaneCulture(game);     // 25 points maximum
            InsaneProsperity(game);  // 25 points maximum
            InsaneSecurity(game);    // 40 points maximum
            InsanityBonus(game);     // 26 points maximum
            InsaneTreasury(game);    // 5 points maximum
            
            if (uInsanity > 101) uInsanity = 101;    
        }

        //////////////////////////////////////////////
        // Insanity Rating - Security contribution 
        // Including bonuses that are security-related
        void InsaneSecurity(IGameQueryInterface game)
        {
            bool b1 = false;
            uint nJS, nJT, numWorkers, maxUIS;
            uint nWeeks = nTime / 20;
            maxUIS = Math.Min(25, nWeeks);
            
            if (nSecurity >= maxUIS)
                uISecurity = 0;
            else
                uISecurity = maxUIS - nSecurity;

            // plague, fire and collapse
            game.GetBuildingsPlagued(out b1);
            if (b1)
            {
                uISecurity++;
                if (!bIAplague)
                {
                    bIAplague = true;
                    DisplayWarning(game, "IA_Plague");
                }
            }
            //game.GetBuildingsCollapsing(out b1);
            if (b1)
            {
                uISecurity++;
                if (!bIAcollapse)
                {
                    bIAcollapse = true;
                    DisplayWarning(game, "IA_Collapse");
                }
            } game.GetBuildingsOnFire(out b1);
            if (b1)
            {
                uISecurity++;
                if (!bIAfire)
                {
                    bIAfire = true;
                    DisplayWarning(game, "IA_Fire");
                }
            }
            
            // useless workers
            numWorkers = 0;
            numWorkers = CountWorkers(game);
            CountEmployees(game);
            if (numWorkers > numEmployed)
                uIWorkers = (numWorkers - numEmployed) / 200;
            else
                uIWorkers = 0;
            uIWorkers = Math.Min(uIWorkers, 5);

            // No Jupiter bonus
            game.GetActiveBuildings(mIDJupiterShrine, out nJS);
            game.GetActiveBuildings(mIDJupiterTemple, out nJT);
            if ((nJS == 0) && (nJT == 0)) uISecurity += 10;
            uISecurity = Math.Min(uISecurity, 35);
            uInsanity += uISecurity;
            uInsanity += uIWorkers;
        }

        ///////////////////////////////////////////////
        // Insanity Rating - Culture contribution 
        void InsaneCulture(IGameQueryInterface game)
        {
            uint nHouses, nPats, num, nCultured, minCR, maxCR, baseCR, n1, n2;
            uint uHealth, uReligion, uEducation, uEntertainment;
            nHouses = NumHomes(game);
            nPats = NumVillas(game);
            game.GetTotalBuildings(mIDVilla1, out num);
            nPats -= num;
            // calculate maximum initial contributions
            // Health first
            uHealth = 0;
            game.GetActiveBuildings(mIDClinic, out num);
            if (num > 0) uHealth += 2500;
            game.GetActiveBuildings(mIDBarber, out num);
            if (num > 0) uHealth += 2500;
            game.GetActiveBuildings(mIDBathhouse, out num);
            if (num > 0) uHealth += 2500;
            game.GetActiveBuildings(mIDHospital, out num);
            if (num > 0) uHealth += 2500;
            baseCR = uHealth;
            // now religion
            uReligion = 0;
            game.GetActiveBuildings(mIDJupiterShrine, out n1);
            game.GetActiveBuildings(mIDJupiterTemple, out n2);
            if ((n1 + n2) > 0) uReligion += 2000;
            game.GetActiveBuildings(mIDMercuryShrine, out n1);
            game.GetActiveBuildings(mIDMercuryTemple, out n2);
            if ((n1 + n2) > 0) uReligion += 2000;
            game.GetActiveBuildings(mIDCeresShrine, out n1);
            game.GetActiveBuildings(mIDCeresTemple, out n2);
            if ((n1 + n2) > 0) uReligion += 2000;
            game.GetActiveBuildings(mIDMarsShrine, out n1);
            game.GetActiveBuildings(mIDMarsTemple, out n2);
            if ((n1 + n2) > 0) uReligion += 2000;
            game.GetActiveBuildings(mIDBacchusShrine, out n1);
            game.GetActiveBuildings(mIDBacchusTemple, out n2);
            if ((n1 + n2) > 0) uReligion += 2000;
            if (uReligion < baseCR) baseCR = uReligion;
            // now education
            uEducation = 0;
            game.GetActiveBuildings(mIDSchool, out num);
            if (num > 0) uEducation += 7000;
            game.GetActiveBuildings(mIDLibrary, out num);
            if (num > 0) uEducation += 3000;
            if (uEducation < baseCR) baseCR = uEducation;
            // finally Entertainment
            uEntertainment = 0;
            game.GetActiveBuildings(mIDOdeum, out num);
            if (num > 0) uEntertainment += 1500;
            game.GetActiveBuildings(mIDTheater, out num);
            if (num > 0) uEntertainment += 2000;
            game.GetActiveBuildings(mIDArena, out num);
            if (num > 0) uEntertainment += 2500;
            game.GetActiveBuildings(mIDColiseum, out num);
            game.GetActiveBuildings(mIDGladiator, out n1);
            game.GetActiveBuildings(mIDAnimalTrainer, out n2);
            if ((num > 0) & (n1 > 0)) uEntertainment += 1500;
            if ((num > 0) & (n2 > 0)) uEntertainment += 3000;
            game.GetActiveBuildings(mIDCircus, out num);
            if (num > 0) uEntertainment += 1000;
            if (uEntertainment < baseCR) baseCR = uEntertainment;
            // Now we have the baseCR we can find the maximum CR
            maxCR = baseCR;
            maxCR += Math.Min(1500, (uHealth - baseCR) / 4);
            maxCR += Math.Min(1500, (uEducation - baseCR) / 4);
            maxCR += Math.Min(1500, (uReligion - baseCR) / 4);
            maxCR += Math.Min(1500, (uEntertainment - baseCR) / 4);
            
            minCR = (maxCR * nPats) / (nHouses + nPats);
            if (maxCR == 0)
                nCultured = 0;
            else if (nCulture < minCR)
                nCultured = 0;
            else
                nCultured = (((nCulture * 100) - minCR) * nHouses) / (maxCR - minCR);

            uICulture = Math.Min(nHouses, 25);
            if (nCultured > uICulture)
                uICulture = 0;
            else
                uICulture -= nCultured;

            uInsanity += uICulture;
        }

        //////////////////////////////////////////////
        // Insanity Rating - Treasury contribution 
        void InsaneTreasury(IGameQueryInterface game)
        {
            if (nCityFunds < 5000)
                uIFunds = 5;
            else if (nCityFunds < 6000)
                uIFunds = 4;
            else if (nCityFunds < 7000)
                uIFunds = 3;
            else if (nCityFunds < 8000)
                uIFunds = 2;
            else if (nCityFunds < 9000)
                uIFunds = 1;
            else
                uIFunds = 0;

            uInsanity += uIFunds;

        }

        /////////////////////////////////////////////
        // Returns the maximum Patrician level
        uint MaxVilla(IGameQueryInterface game)
        {
            uint num, uMaxPat = 0;
            Int32 mID = 0;
            for (int i = 0; i < 9; i++)
            {
                mID = IDMaker.FromString(sPatricians[i]);
                game.GetTotalBuildings(mID, out num);
                if (num > 0) uMaxPat = (uint)i;
            }
            return uMaxPat;
        }

        //////////////////////////////////////////
        // Returns the number of Patrician houses
        uint NumVillas(IGameQueryInterface game)
        {
            uint num, numPats = 0;
            Int32 mID = 0;
            for (int i = 0; i < 9; i++)
            {
                mID = IDMaker.FromString(sPatricians[i]);
                game.GetTotalBuildings(mID, out num);
                numPats += num;
            }
            return numPats;
        }

        ////////////////////////////////////////////////////////////////////////////////////
        // Counts the number of homes for 'coverage' purposes in calculating Insanity Rating
        uint NumHomes(IGameQueryInterface game)
        {
            Int32 mID;
            uint num, nHomes = 0;
            string[] sHomes = {"C4b Plebian home 01", "C4b Plebian home 02", "C4b Plebian home 03",
                              "C4b Equites Housing 01", "C4b Equites Housing 02", "C4b Equites Housing 03"};

            for (int i = 0; i < 6; i++)
            {
                mID = IDMaker.FromString(sHomes[i]);
                game.GetActiveBuildings(mID, out num);
                nHomes += num;
            }
            return nHomes;
        }

        ///////////////////////////////////////////////
        // Insanity Rating - Prosperity contribution 
        void InsaneProsperity(IGameQueryInterface game)
        {
            uint nI1, nI2, nI3, nD1, nD2, nD3, nHomes, nPenalty;
            game.GetActiveBuildings(mIDInsula1, out nI1);
            game.GetActiveBuildings(mIDInsula2, out nI2);
            game.GetActiveBuildings(mIDInsula3, out nI3);
            game.GetActiveBuildings(mIDDomus1, out nD1);
            game.GetActiveBuildings(mIDDomus2, out nD2);
            game.GetActiveBuildings(mIDDomus3, out nD3);
            nHomes = nI1 + nI2 + nI3 + nD1 + nD2 + nD3;
            nPenalty = nI2 + 2 * nI3 + nD2 + 2 * nD3;

            if (nPenalty >= nHomes)
                uIProsperity = 0;
            else if (nHomes > 25)
                uIProsperity = 25 - nPenalty;
            else
                uIProsperity = nHomes - nPenalty;

            uInsanity += uIProsperity;
        }

                //////////////////////////////////////////////
        // Insanity Rating - Bonus contribution 
        // This is mainly down to resources but also includes useless citizens (unemployed) and useless trade routes
        void InsanityBonus(IGameQueryInterface game)
        {
            uint nIR, num, uIBonus = 0;
            // useless resources
            game.GetResource(mIDArmor, out num);
            nIR = num;
            game.GetResource(mIDTimber, out num);
            nIR += num;
            game.GetResource(mIDClay, out num);
            nIR += num;
            game.GetResource(mIDSand, out num);
            nIR += num;
            game.GetResource(mIDGold, out num);
            nIR += num;
            game.GetResource(mIDIron, out num);
            nIR += num;
            game.GetResource(mIDMarble, out num);
            nIR += num;
            game.GetResource(mIDWool, out num);
            uIResource = Math.Min((nIR / 64) + (num / 32), 25);
            uIBonus = uIResource;

            uInsanity += uIBonus;
            if (uInsanity > 96) uInsanity = 96;    
        }

        ///////////////////////////////////////////
        // Display a tip on improving insanity
        void InsanityHint(IGameQueryInterface game)
        {
            int iMax = 0;
            uint[] zInsanity = { 0, 0, 0, 0, 0, 0 };
            String[] sHint = { "ICulture", "IProsperity", "ISecurity", "IFunds", "IResources", "IWorkers" };
            if (NumHomes(game) < 25)
            {
                sHint[0] = "ICulture2";
                sHint[1] = "IProsperity2";
            }

            zInsanity[0] = 25 - uICulture;
            zInsanity[1] = 25 - uIProsperity;
            zInsanity[2] = 25 - Math.Min(uISecurity, 25);
            zInsanity[3] = 5 - uIFunds;
            zInsanity[4] = 20 - uIResource;
            zInsanity[5] = 5 - uIWorkers;

            for (int i = 0; i < 5; i++)
            {
                if (zInsanity[i] > zInsanity[iMax]) iMax = i;
            }

            DisplayWarning(game, (sHint[iMax] + "_Tip"));
            tInsanityTip += 320;

        }
        /////////////////////////////////////////////////////////////
        // Counts the number of housing available for equites & plebs
        // (why not just use population less patricians?)
        uint CountWorkers(IGameQueryInterface game)
        {
            uint n1, n2, n3, numWorkers;
            game.GetActiveBuildings(mIDDomus1, out n1);
            game.GetActiveBuildings(mIDDomus2, out n2);
            game.GetActiveBuildings(mIDDomus3, out n3);
            numWorkers = (n1 * 40) + (n2 * 60) + (n3 * 80);
            game.GetActiveBuildings(mIDInsula1, out n1);
            game.GetActiveBuildings(mIDInsula2, out n2);
            game.GetActiveBuildings(mIDInsula3, out n3);
            numWorkers += (n1 * 70) + (n2 * 110) + (n3 * 150);
            return numWorkers;
        }

        ///////////////////////////////////////////////////////////
        // Calculates the number of employees needed to fill all jobs
        void CountEmployees(IGameQueryInterface game)
        {
            numEmployed = 3;       // assume there is a governor's residence
            AddEmployees(game, mIDDrillYard, 54);
            AddEmployees(game, mIDFountain, 3);
            AddEmployees(game, mIDReservoir, 24);
            AddEmployees(game, mIDPumphouse, 18);
            AddEmployees(game, mIDTaxOffice, 14);
            AddEmployees(game, mIDForum, 22);
            AddEmployees(game, mIDBasilica, 36);
            AddEmployees(game, mIDOdeum, 18);
            AddEmployees(game, mIDTheater, 27);
            AddEmployees(game, mIDActor, 21);
            AddEmployees(game, mIDArena, 42);
            AddEmployees(game, mIDGladiator, 30);
            AddEmployees(game, mIDColiseum, 54);
            AddEmployees(game, mIDAnimalTrainer, 36);
            AddEmployees(game, mIDCircus, 99);
            AddEmployees(game, mIDCharioteer, 31);
            AddEmployees(game, mIDSchool, 18);
            AddEmployees(game, mIDLibrary, 45);
            AddEmployees(game, mIDClinic, 22);
            AddEmployees(game, mIDBarber, 12);
            AddEmployees(game, mIDBathhouse, 38);
            AddEmployees(game, mIDHospital, 63);
            AddEmployees(game, mIDJupiterShrine, 15);
            AddEmployees(game, mIDMarsShrine, 15);
            AddEmployees(game, mIDCeresShrine, 15);
            AddEmployees(game, mIDBacchusShrine, 15);
            AddEmployees(game, mIDMercuryShrine, 15);
            AddEmployees(game, mIDJupiterTemple, 33);
            AddEmployees(game, mIDMarsTemple, 33);
            AddEmployees(game, mIDCeresTemple, 33);
            AddEmployees(game, mIDBacchusTemple, 33);
            AddEmployees(game, mIDMercuryTemple, 33);
            // plebs
            AddEmployees(game, mIDSheepFarm, 31);
            AddEmployees(game, mIDSandCamp, 27);
            AddEmployees(game, mIDClayCamp, 27);
            AddEmployees(game, mIDLumberjack, 40);
            AddEmployees(game, mIDIronMine, 42);
            AddEmployees(game, mIDGoldMine, 42);
            AddEmployees(game, mIDMarbleCamp, 72);
            AddEmployees(game, mIDGlassFactory, 40);
            AddEmployees(game, mIDPotteryFactory, 40);
            AddEmployees(game, mIDJewelryFactory, 48);
            AddEmployees(game, mIDOliveOilFactory, 40);
            AddEmployees(game, mIDWineFactory, 48);
            AddEmployees(game, mIDUtensilsFactory, 48);
            AddEmployees(game, mIDWeaponsFactory, 63);
            AddEmployees(game, mIDFoodMarket, 18);
            AddEmployees(game, mIDBasicMarket, 27);
            AddEmployees(game, mIDLuxuryMarket, 31);
            AddEmployees(game, mIDExoticMarket, 39);
            AddEmployees(game, mIDGranary, 18);
            AddEmployees(game, mIDWarehouse, 22);
            AddEmployees(game, mIDDepot, 27);
            AddEmployees(game, mIDPort, 30);
            AddEmployees(game, mIDArmory, 54);
            AddEmployees(game, mIDMessHall, 38);
            AddEmployees(game, mIDTower, 38);
            AddEmployees(game, mIDGatehouse, 45);
        }

        ////////////////////////////////////////////////////////////////////
        // Adds the number of employees needed for the specified building
        // We count mothballed, inactive venues, untaxed markets
        void AddEmployees(IGameQueryInterface game, Int32 mID, uint iEmploy)
        {
            uint num = 0;
            game.GetTotalBuildings(mID, out num);
            numEmployed += iEmploy * num;
        }

        /////////////////////////////////////////////////////////////////////////
        // This controls the Golden Fleece sequence based on the value of iFleece
        void JasonStory(IGameQueryInterface game)
        {
            uint nB1, nB2, nB3, nR1, nR2, nR3, nR4;
            tFleece = nTime + 5;

            switch (iFleece)
            {
                case 1:
                    // First Act - build the Argo!
                    if (iState == 0)
                    {
                        DisplayTutorial(game);
                    }
                    else if (iState == 1)
                    {
                        uFleece = 1;
                        game.GetResource(mIDTimber, out nR1);
                        game.GetResource(mIDGrain, out nR2);
                        if ((nR1 >= 25) && (nR2 >= 25))
                        {
                            NoteProgress(game, "Argo_Building");
                        }
                    }
                    else if (iState == 2)
                    {
                        NoteProgress(game, "Argo_25");
                    }
                    else if (iState == 3)
                    {
                        NoteProgress(game, "Argo_50");
                    }
                    else if (iState == 4)
                    {
                        NoteProgress(game, "Argo_75");
                    }
                    else if (iState == 5)
                    {
                        NoteProgress(game, "Argo_99");
                    }
                    else
                    {
                        FleeceDone(game);
                        game.OpenTradeRoute(kPagasae);
                        game.FlashUIControl(mUIIDStorage, Toolset.MainGameFormID, 1000);
                    }
                    break;

                case 2:
                    // Second Act - Attract the Crew!
                    if (iState == 0)
                    {
                        DisplayTutorial(game);
                        game.UnlockUIControl(mUIIDPatHome, Toolset.MainGameFormID);
                        iWarn = 0;
                    }
                    else if (iState == 1)
                    {
                        game.GetTotalBuildings(mIDVilla3, out nB1);
                        game.GetResource(mIDGrain, out nR1);
                        game.GetResource(mIDVegetables, out nR2);
                        game.GetResource(mIDMeat, out nR3);
                        game.GetResource(mIDWine, out nR4);
                        uint nFood = nR1 + nR2 + nR3;
                        if (bHercules && bAtalanta && bJason)
                        {
                            FleeceDone(game);
                            game.OpenTradeRoute(kPherae);
                            game.FlashUIControl(mUIIDStorage, Toolset.MainGameFormID, 1000);
                        }
                        else if (!bJason && (nFood >= 64) && (nB1 > nHeroes))
                        {
                            bJason = true;
                            DisplayWarning(game, "Jason");
                            nHeroes++;
                        }
                        else if (!bHercules && (nR4 >= 32) && (nB1 > nHeroes))
                        {
                            bHercules = true;
                            DisplayWarning(game, "Hercules");
                            nHeroes++;
                        }
                        else if (!bAtalanta && (nR3 >= 32) && (nB1 > nHeroes))
                        {
                            bAtalanta = true;
                            DisplayWarning(game, "Atalanta");
                            nHeroes++;
                        }
                        else if (iWarn == 32)
                        {
                            if (nB1 < 3) SilentWarning(game, "Hero_Halls");
                            if (!bJason) SilentWarning(game, "Jason_Needs");
                            if (!bHercules) SilentWarning(game, "Hercules_Needs");
                            if (!bAtalanta) SilentWarning(game, "Atalanta_Needs");
                            iWarn = 0;
                        }
                        iWarn++;
                    }
                    break;

                case 3:
                    // Defeat the Sharpies!
                    if (iState == 0)
                    {
                        game.UnlockUIControl(mUIIDArena, Toolset.MainGameFormID);
                        game.UnlockUIControl(mUIIDGladiator, Toolset.MainGameFormID);
                        DisplayTutorial(game);
                        uFleece = 3;
                        iWarn = 0;
                    }
                    else
                    {
                        game.GetActiveBuildings(mIDArena, out nB1);
                        if (nB1 > 0)
                        {
                            FleeceDone(game);
                            game.OpenTradeRoute(kSalmydessus);
                            game.FlashUIControl(mUIIDStorage, Toolset.MainGameFormID, 1000);
                        }
                        else if (iWarn == 32)
                        {
                            DisplayWarning(game, "Arena");
                            iWarn = 0;
                        }
                        else
                            iWarn++;
                    }
                    break;

                case 4:
                    // Win the heart of Madea!
                    if (iState == 0)
                    {
                        DisplayTutorial(game);
                        game.UnlockUIControl(mUIIDObelisk, Toolset.MainGameFormID);
                        iWarn = 0;
                        uFleece = 4;
                    }
                    else
                    {
                        game.GetResource(mIDPerfume, out nR1);
                        game.GetResource(mIDSilphium, out nR2);
                        game.GetTotalBuildings(mIDObelisk, out nB1);
                        game.GetActiveBuildings(mIDTheater, out nB2);
                        if ((nR1 >= 4) && (nR2 >= 4) && (nB1 > 0) && (nB2 > 0))
                        {
                            FleeceDone(game);
                            game.OpenTradeRoute(kColchis);
                            game.FlashUIControl(mUIIDStorage, Toolset.MainGameFormID, 1000);
                        }
                        else if (iWarn == 32)
                        {
                            if (nR1 <= 4) DisplayWarning(game, "Perfume");
                            if (nR2 <= 4) DisplayWarning(game, "Silphium");
                            if (nB1 < 1) DisplayWarning(game, "Obelisk");
                            if (nB2 < 1) DisplayWarning(game, "Theater");
                            iWarn = 0;
                        }
                        iWarn++;
                    }
                    break;

                case 5:
                    // Yoke the Fire-Breathing Bulls...
                    if (iState == 0)
                    {
                        DisplayTutorial(game);
                        uFleece = 5;
                        iWarn = 0;
                    }
                    else
                    {
                        game.GetActiveBuildings(mIDCattleFarm, out nB1);
                        game.GetActiveBuildings(mIDPrefect, out nB2);
                        game.GetActiveBuildings(mIDArena, out nB3);
                        game.GetResource(mIDCosmetics, out nR1);
                        game.GetResource(mIDHoney, out nR2);
                        if ((nB1 >= 2) && (nB2 >= 8) && (nB1 > 0) && (nR1 >= 4) && (nR2 >= 4))
                        {
                            FleeceDone(game);
                            game.TriggerFireDamage(mIDArena, 1, 80);
                        }
                        else if (iWarn == 32)
                        {
                            if (nR1 <= 4) DisplayWarning(game, "Cosmetics");
                            if (nR2 <= 4) DisplayWarning(game, "Honey");
                            if (nB1 < 2) DisplayWarning(game, "Cattle");
                            if (nB2 < 8) DisplayWarning(game, "Prefect");
                            if (nB3 < 1) DisplayWarning(game, "Arena2");
                            iWarn = 0;
                        }
                        iWarn++;
                    }
                    break;

                case 6:
                    // Fight the Serpent Teeth Army!...
                    if (iState == 0)
                    {
                        DisplayTutorial(game);
                        game.UnlockUIControl(mUIIDMarble, Toolset.MainGameFormID);
                        uFleece = 6;
                        iWarn = 0;
                    }
                    else if (iState == 1)
                    {
                        game.GetResource(mIDMarble, out nR1);
                        game.GetActiveBuildings(mIDArena, out nB1);
                        if ((nR1 >= 12) && (nB1 > 0))
                        {
                            FleeceDone(game);
                        }
                        else if (iWarn == 32)
                        {
                            if (nR1 <= 12) DisplayWarning(game, "Marble");
                            if (nB1 < 1) DisplayWarning(game, "Arena3");
                            iWarn = 0;
                        }
                        iWarn++;
                    }
                    break;

                case 7:
                    // Retrieve the Golden Fleece!
                    if (iState == 0)
                    {
                        DisplayTutorial(game);
                        game.UnlockUIControl(mUIIDColiseum, Toolset.MainGameFormID);
                        uFleece = 7;
                        iWarn = 0;
                    }
                    else if (iState == 1)
                    {
                        game.GetResource(mIDIncense, out nR1);
                        game.GetActiveBuildings(mIDColiseum, out nB1);
                        game.GetActiveBuildings(mIDAnimalTrainer, out nB2);
                        game.GetActiveBuildings(mIDMarsTemple, out nB3);
                        if ((nR1 >= 8) && (nB1 > 0) && (nB2 > 0) && (nB3 > 0))
                        {
                            FleeceDone(game);
                            tFleeceWon = nTime;
                            game.OpenTradeRoute(kAresGrove);
                            game.FlashUIControl(mUIIDStorage, Toolset.MainGameFormID, 1000);
                        }
                        else if (iWarn == 32)
                        {
                            if (nR1 <= 8) DisplayWarning(game, "Incense");
                            if (nB1 < 1) DisplayWarning(game, "Coliseum");
                            if (nB2 < 1) DisplayWarning(game, "Animal");
                            if (nB3 < 1) DisplayWarning(game, "Mars");
                            iWarn = 0;
                        }
                        iWarn++;
                    }
                    break;

                case 8:
                    break;
                
            }

        }

        //////////////////////////////////////////
        // Send 'Fleece done message' to player
        void FleeceDone(IGameQueryInterface game)
        {
            string msgBegin = "Done_" + iFleece.ToString();
            msgTitle = msgBegin + "_Title";
            msgText = msgBegin + "_Text";
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplaySignificant, ref msgTitle, ref msgText, ref msgBaa);
            iFleece++;
            iState = 0;
            tFleece += 15;
        }

        //////////////////////////////////////////
        // Send 'tutorial message' to player
        void DisplayTutorial(IGameQueryInterface game)
        {
            string msgBegin = "Tutorial_";
            msgTitle = msgBegin + iFleece.ToString() + "_Title";
            msgText = msgBegin + iFleece.ToString() + "_Message";
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplayTutorial, ref msgTitle, ref msgText, ref msgSound);
            iState++;
            tFleece += 15;
        }

        ///////////////////////////////////////////////////////////
        // Send one-line notification to player of Fleece progress
        void NoteProgress(IGameQueryInterface game, String msgWarn)
        {
            game.SendWarningMessage(ref msgWarn, ref msgSound);
            iState++;
            tFleece += 15;
        }


        /////////////////////////////////////////////
        // Send message with applause to player
        void GiveAcclamation(IGameQueryInterface game, String sMessage)
        {
            msgTitle = sMessage + "_Title";
            msgText = sMessage + "_Text";
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplaySignificant, ref msgTitle, ref msgText, ref msgApplause);
        }

        /////////////////////////////////////////////
        // Send basic message to player
        void DisplayMessage(IGameQueryInterface game, String sMessage)
        {
            msgTitle = sMessage + "_Title";
            msgText = sMessage + "_Text";
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplaySignificant, ref msgTitle, ref msgText, ref msgSound);
        }

        /////////////////////////////////////////////
        // Send Insanity Day message to player
        void DisplaySpecialInsanity(IGameQueryInterface game, String sMessage)
        {
            msgTitle = sMessage + "_Insanity";
            msgText = "Insanity_Rating_" + nInsanity.ToString();
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplaySignificant, ref msgTitle, ref msgText, ref msgBaa);
        }

        //////////////////////////////////////////////
        // Show Insanity Rating to player
        void DisplayInsanity(IGameQueryInterface game)
        {
            SilentWarning(game, "Insanity_Rating_" + nInsanity.ToString());
        }

        //////////////////////////////////////////////
        // Show Maximum Insanity Rating to player
        void DisplayMaxInsanity(IGameQueryInterface game)
        {
            msgTitle = "Insanity_Max";
            msgText = "Insanity_Rating_" + uMaxInsanity.ToString();
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplaySignificant, ref msgTitle, ref msgText, ref msgBaa);
        }


        /////////////////////////////////////////////
        // Send 'warning' to player
        void DisplayWarning(IGameQueryInterface game, String msgWarn)
        {
            game.SendWarningMessage(ref msgWarn, ref msgSound);
        }

        /////////////////////////////////////////////
        // Send silent 'warning' to player
        void SilentWarning(IGameQueryInterface game, String msgWarn)
        {
            String msgNone = "";
            game.SendWarningMessage(ref msgWarn, ref msgNone);
        }

        //////////////////////////////////////////
        // Send 'riot warning' to player
        void DisplayRiot(IGameQueryInterface game, String sMessage)
        {
            msgTitle = sMessage + "_Title";
            msgText = sMessage + "_Text";
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplaySignificant, ref msgTitle, ref msgText, ref msgRiot);
        }

        /////////////////////////////////////////////////
        // Returns > 0 if palace built (1, 3 or 5) else 0
        private uint nPalace(IGameQueryInterface game)
        {
            UInt32 num = 0;
            game.GetActiveBuildings(mIDPalace3, out num);
            if (num > 0) return 5;
            game.GetActiveBuildings(mIDPalace2, out num);
            if (num > 0) return 3;
            game.GetActiveBuildings(mIDPalace1, out num);
            if (num > 0) return 1;
            return 0;
        }

        /////////////////////////////////////////////////////
        // Returns 0 if no palace else the ID of the building
        private Int32 mPalace(IGameQueryInterface game)
        {
            UInt32 num = 0;
            game.GetActiveBuildings(mIDPalace3, out num);
            if (num > 0) return mIDPalace3;
            game.GetActiveBuildings(mIDPalace2, out num);
            if (num > 0) return mIDPalace2;
            game.GetActiveBuildings(mIDPalace1, out num);
            if (num > 0) return mIDPalace1;
            return 0;
        }

        //////////////////////////////////////////////
        // Send timer warning message
        void TimerMessage(IGameQueryInterface game)
        {
            DisplayWarning(game, (sTimeLeft[iMessage] + "_Months_Left"));
            iMessage++;    
        }

        //////////////////////////////////////////////
        // Called to trigger the Defeat condition
        void TriggerDefeat(IGameQueryInterface game)
        {
            game.OpenTradeRoute(kDefeat);
            game.ScriptDone = true;
        }

        //////////////////////////////////////////////////////
        // return control panel buttons to their initial state
        void StopCurrentInvasion(IGameQueryInterface game)
        {
            Int32[] iCohorts;
            String orders = sCohortOrders.kFlee;
            DisplayWarning(game, "Arashh_Goes");
            game.BuildingsRazed = 0;
            bArashh = false;
            game.StopInvasion(ref invasion, true);
            game.GetInvaderCohorts(ref invasion, out iCohorts);
            foreach (Int32 cohortID in iCohorts)
                game.SetCohortOrders(cohortID, ref orders); 
        }

        void ScorePoints(IGameQueryInterface game)
        {
            uint gSalary;
            game.GetGovernorSalaryLevel(out gSalary);
            if (gSalary == 0)
            {
                game.SetRomeStandardRate(true, (int)uMaxInsanity);
                game.SetRomeStandardRate(false, (int)tFleeceWon);
            }
            else
            {
                game.SetRomeStandardRate(true, (int)(wFinalTreasury / 100000));
                game.SetRomeStandardRate(false, (int)wFinalTreasury);
            }
        }

        //////////////////////////////////////////////////////
        // return control panel buttons to their initial state
        private void ResetBaseUI(IGameQueryInterface game)
        {
            game.LockUIControl(-520227242, Toolset.EmpireLevelFormID);
            game.LockUIControl(mUIIDPlaza1, Toolset.MainGameFormID);
            game.LockUIControl(mUIIDPlaza2, Toolset.MainGameFormID);
            game.LockUIControl(mUIIDPlaza3, Toolset.MainGameFormID);
            game.LockUIControl(mUIIDWall, Toolset.MainGameFormID);
            
            if (iFleece < 2) game.LockUIControl(mUIIDPatHome, Toolset.MainGameFormID);
            if (iFleece < 3)
            {
                game.LockUIControl(mUIIDArena, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDGladiator, Toolset.MainGameFormID);
            }
            if (iFleece < 4) game.LockUIControl(mUIIDObelisk, Toolset.MainGameFormID);
            if (iFleece < 6) game.LockUIControl(mUIIDMarble, Toolset.MainGameFormID);
            if (iFleece < 7) game.LockUIControl(mUIIDColiseum, Toolset.MainGameFormID);
                
        }

        void OnBeginScenario(IGameQueryInterface game)
        {
            mMilitaryAI = new TMilitaryAI(game);
            
            // ensure the standard wage is set properly (only necessary on first load)
            mWageManagerPlebe = new StandardWageManager(game, eWageTypes.kPleb, 0);
            mWageManagerEques = new StandardWageManager(game, eWageTypes.kEques, 0);
            mWageManagerPlebe.SetGameWage(game);
            mWageManagerEques.SetGameWage(game);

            bInit = true;
            game.ScriptDone = false;
        }

        // Initialization needed on scenario load (when loading save games)
        void OnScenarioLoad(IGameQueryInterface game)
        {
            bInit = true;
            game.ScriptDone = false;
        }

        void OnInvasionArrival(IGameQueryInterface game)
        {
            Int32[] enemyCohorts;
            String invasion = game.RunInvasion;
            String[] sTargets = { "C4b Plebian home 01", "C4b Plebian home 02", "C4b Plebian home 03" };
            String orders = "RazeBuildings";
            game.GetInvaderCohorts(ref invasion, out enemyCohorts);
            foreach (Int32 cohortID in enemyCohorts)
            {
                game.SetCohortOrders(cohortID, ref orders);
                game.SetCohortTargets(cohortID, ref sTargets);
            }
        }

        void OnCohortTargetDestroyed(IGameQueryInterface game)
        {
            // do nothing...           
        }
    }
}

